"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Plugin that caches information from the package manager after installation to speed up resolution of imports.
 * @beta
 */
class RushResolverCachePlugin {
    constructor() {
        this.pluginName = 'RushResolverCachePlugin';
    }
    apply(rushSession, rushConfiguration) {
        rushSession.hooks.afterInstall.tapPromise(this.pluginName, async (command, subspace, variant) => {
            const logger = rushSession.getLogger('RushResolverCachePlugin');
            if (rushConfiguration.packageManager !== 'pnpm') {
                logger.emitError(new Error('The RushResolverCachePlugin currently only supports the "pnpm" package manager'));
                return;
            }
            const pnpmMajorVersion = parseInt(rushConfiguration.packageManagerToolVersion, 10);
            // Lockfile format parsing logic changed in pnpm v8.
            if (pnpmMajorVersion < 8) {
                logger.emitError(new Error('The RushResolverCachePlugin currently only supports pnpm version >=8'));
                return;
            }
            // This plugin is not currently webpacked, but these comments are here for future proofing.
            const { afterInstallAsync } = await Promise.resolve().then(() => __importStar(require(
            /* webpackChunkMode: 'eager' */
            /* webpackExports: ["afterInstallAsync"] */
            './afterInstallAsync')));
            await afterInstallAsync(rushSession, rushConfiguration, subspace, variant, logger);
        });
    }
}
exports.default = RushResolverCachePlugin;
//# sourceMappingURL=index.js.map